# Copyright 2018 Google Inc.
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# ----------------------------------------------------------------------------
#
#     ***     AUTO GENERATED CODE    ***    AUTO GENERATED CODE     ***
#
# ----------------------------------------------------------------------------
#
#     This file is automatically generated by Magic Modules and manual
#     changes will be clobbered when the file is regenerated.
#
#     Please read more about how to change this file in README.md and
#     CONTRIBUTING.md located at the root of this package.
#
# ----------------------------------------------------------------------------

# An example Puppet manifest that ensures Google Cloud Computing DNS Managed
# Zones in a project do not exist.

# Getting Started
# ---------------
# The following example requires two environment variables to be set:
#     * cred_path - a path to a JSON service account file
#     * project - the name of your GCP project
#
# If running from the command line you can pass these via Facter:
#
#   FACTER_cred_path=/path/to/my/cred.json \
#   FACTER_project='my-test-project'
#       puppet apply examples/delete_managed_zone.pp
#
# For convenience you optionally can add it to your ~/.bash_profile (or the
# respective .profile settings) environment:
#
#   export FACTER_cred_path=/path/to/my/cred.json
#   export FACTER_project='my-test-project'
#
# Authenticating to GCP
# ---------------------
# `gauth_credential` defines a credential to be used when communicating with
# Google Cloud Platform.
#
# For more information on the gauth_credential parameters and providers please
# refer to its detailed documentation at:
#
#   https://forge.puppet.com/google/gauth
#
gauth_credential { 'mycred':
  path     => $cred_path, # e.g. '/home/nelsonjr/my_account.json'
  provider => serviceaccount,
  scopes   => [
    'https://www.googleapis.com/auth/ndev.clouddns.readwrite',
  ],
}

# Ensures the managed zone is not in the project.
gdns_managed_zone { 'test-example-zone':
  ensure     => absent,
  project    => $project, # e.g. 'my-test-project'
  credential => 'mycred',
}

# Ensures the managed zone is not in the project.
gdns_managed_zone { 'testzone-2-com':
  ensure     => absent,
  project    => $project, # e.g. 'my-test-project'
  credential => 'mycred',
}

# Ensures the managed zone is not in the project.
gdns_managed_zone { 'id-for-testzone-3-com':
  ensure     => absent,
  project    => $project, # e.g. 'my-test-project'
  credential => 'mycred',
}

gdns_managed_zone { 'testzone-4-com':
  ensure     => absent,
  project    => $project, # e.g. 'my-test-project'
  credential => 'mycred',
}
